# 银联挑战赛复赛A,B题_算法日常[8/100]

<!--more-->

## 缘起
8月10号是计算机设计大赛决赛答辩的最后一天，这天下午是牛客多校8，晚上是银联挑战赛复赛，队友出去吃吃喝喝了，我点个外卖，打着比赛，然后第一题就卡住不会做，然后自闭了，果然银联的比赛很重视数学题啊啊啊，是我数学题没怎么练，太菜了--->所以菜导致既没有吃到好东西，又导致爆零没太多收获，所以还是需要多多努力

## A题
### 爱喝「肥宅快乐水」的班长
[爱喝「肥宅快乐水」的班长](https://nanti.jisuanke.com/t/40548)

### 题目解法
![A_an](https://cdn.jsdelivr.net/gh/wolfdan666/BlogPic/%E7%AE%97%E6%B3%95/%E6%AF%94%E8%B5%9B/%E7%BA%BF%E4%B8%8A/2019%E9%93%B6%E8%81%94%E6%8C%91%E6%88%98%E8%B5%9B%E5%A4%8D%E8%B5%9B/A_an.png)

### 看不懂的知识链接
[隔板法](https://zh.wikipedia.org/wiki/%E9%9A%94%E6%9D%BF%E6%B3%95)

扩展的隔板法中：

转化前的空盒 == 转化后每个盒子至少放一个

### AC代码
```cpp
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll mod=1000000007;
const int inf = 0x3f3f3f3f;
const int M = 2e3+7;
int C[M][M];
int T,n,m;

void add(ll &a,ll v){
    a += v;
    if(a >= mod) a-=mod;
}

void pre(){
    for(int i=0;i<M;i++){
        C[i][0]=1;
        for(int j=1;j<=i;j++){
            C[i][j]=C[i-1][j-1]+C[i-1][j];
            if(C[i][j]>=mod) C[i][j]-=mod;
        }
    }
}

int main(){
    ios::sync_with_stdio(false);cin.tie(0);
    cin>>T;
    pre();
    while(T--){
        cin>>n>>m;
        cout<<C[n+m-2][m-1]<<endl;
    }

    return 0;
}
```


## B题
### 整数对
[整数对](https://nanti.jisuanke.com/t/40549)

### 题目解法
![B_an](https://cdn.jsdelivr.net/gh/wolfdan666/BlogPic/%E7%AE%97%E6%B3%95/%E6%AF%94%E8%B5%9B/%E7%BA%BF%E4%B8%8A/2019%E9%93%B6%E8%81%94%E6%8C%91%E6%88%98%E8%B5%9B%E5%A4%8D%E8%B5%9B/B_an.png)

### AC代码
```cpp
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
ll T,n,m,p,ans;

int main(){
    ios::sync_with_stdio(false);cin.tie(0);
    cin>>T;
    while(T--){
        cin>>n>>m>>p;
        ans = 0;
        ll x = n/p;
        for(ll r = 0; r < p ; r++ ){
            /*求出b的种类数*/
            ll bn = m/(p/__gcd(r,p));
            /*分别对应题解的1,2,3种情况,其实1,3可以合并*/
            if(!r) ans+=x*bn;
            else if(0<r && r<=n%p) ans+=(x+1)*bn;
            else ans+=x*bn;
        }
        cout<<ans<<endl;

    }

    return 0;
}
```


## 每天一句叨叨
人心的成见如同一座大山，我们总是口上说不能有偏见，其实真正的内心想法却不是这样的...

所以我对别人的偏见，我只能尽量克制，让自己理性对待，然后做之不止，乃成君子

对于别人对自己的偏见不要在意，而是要专注自己的目标

感觉自己生来就有一种追求挑战的血液，在小时候尤为明显，但是感觉在长久的教化过程中削弱了，所以我想要找回本真，生命不息，战斗不止，和天生的不公斗到底，做自己的英雄

